11.20.28   os32: sysroutine(9)

NOME

    s_sysroutine - attuazione delle chiamate di sistema

SINTASSI

    <kernel/proc.h>
    extern pid_t <proc_current>;
    void sysroutine (uint32_t <syscallnr>, uint32_t <msg_off>, uint32_t <msg_size>);

ARGOMENTI

    Argomento            Descrizione
    pid_t <proc_current> Il numero del processo interrotto.

    uint32_t <syscallnr> Il numero della chiamata di sistema.

                         Nonostante il tipo di variabile, si tratta del
    uint32_t <msg_off>   puntatore alla posizione di memoria in cui inizia il
                         messaggio con gli argomenti della chiamata di sistema,
                         ma tale puntatore e` valido solo nell'ambito del
                         segmento dati del processo interrotto.
    uint32_t <msg_size>  La lunghezza del messaggio della chiamata di sistema.

DESCRIZIONE

    La funzione <sysroutine()> viene chiamata esclusivamente dalla routine
    isr_128, contenuta nel file kernel/ibm_i386/isr.s [12.6.21], a seguito di
    una chiamata di sistema.

    Inizialmente, la funzione individua l'indirizzo corrispondente alla
    posizione del messaggio proveniente dal processo, dal punto di vista del
    kernel; in pratica traduce <msg_off> in qualcosa di adatto al kernel.

    Attraverso un'unione di variabili strutturate, tutti i tipi di messaggi
    gestibili per le chiamate di sistema vengono dichiarati assieme in un'unica
    area di memoria. Successivamente, la funzione deve trasferire il messaggio,
    dall'indirizzo calcolato precedentemente all'inizio dell'unione in
    questione.

    Quando la funzione e` in grado di accedere ai dati del messaggio, procede
    con una grande struttura di selezione, sulla base del tipo di messaggio,
    quindi esegue cio` che e` richiesto, avvalendosi prevalentemente di altre
    funzioni, interpretando il messaggio in modo diverso a seconda del tipo di
    chiamata.

    Il messaggio originale viene poi sovrascritto con le informazioni prodotte
    dall'azione richiesta, in particolare viene trasferito anche il valore
    della variabile <errno> del kernel, in modo che possa essere recepita anche
    dal processo che ha eseguito la chiamata, in caso di esito erroneo.
    Pertanto, il messaggio viene riscritto a partire dall'indirizzo da cui era
    stato copiato precedentemente, in modo da renderlo disponibile
    effettivamente al processo chiamante.

    Quando la funzione <sysroutine()> ha finito il suo lavoro, chiama a sua
    volta proc_scheduler(9) [11.20.10], perche' con l'occasione provveda
    eventualmente alla sostituzione del processo attivo con un altro che si
    trovi nello stato di pronto.

VALORE RESTITUITO

    La funzione non restituisce alcun valore, in quanto tutto cio` che c'e` da
    restituire viene trasmesso con la riscrittura del messaggio, nell'area di
    memoria originale.

FILE SORGENTI

    lib/sys/os32/sys.s [13.21.7]

    kernel/proc.h [12.14]

    kernel/ibm_i386/isr.s [12.6.21]

    kernel/proc/sysroutine.c [12.14.28]

VEDERE ANCHE

    sys(2) [5.56], proc_scheduler(9) [11.20.10], dev_io(9) [11.4.1], lib_s(9) [
    11.12].

